// TODO `nmp install csvtojson`
// TODO make sure your .env variables are named correctly

const { MongoClient } = require("mongodb");
const dotenv = require("dotenv");

const csv = require("csvtojson");

dotenv.config();

                                                                                                                                      
const url = `mongodb+srv://${process.env.DB_USER}:${process.env.DB_PASS}@${process.env.DB_HOST}/Zip-Codes?retryWrites=true&w=majority&useNewUrlParser=true&useUnifiedTopology=true`;
const client = new MongoClient(url);

async function run() {
    try {
        // load and parse a CSV file
        const data = await csv({
            colParser: {
                "EstimatedPopulation": "number",
                "Lat": "number",
                "Long": "number",
                "TaxReturnsFiled": "number",
                "TotalWages": "number",
                "Decommisioned": (n) => n.toLocaleLowerCase() === "true"
            }
        }).fromFile("zipcodes/zipcodes.csv");

        // connect to MongoDB
        await client.connect();
        console.log("Connected correctly to server");

        // select a collection from the default database (from the connection string)
        const collection = client.db().collection("zips");

        // delete all of the previous documents
        await collection.deleteMany({});
        console.log("Cleared old data");

        // insert all entries from data
        await collection.insertMany(data);
        console.log("Inserted new data");

    } catch (err) {
        console.log(err.stack);
    }
    finally {
        await client.close();
    }
}

run().catch(console.dir);